# Spring Cloud Contract Maven Plugin – spring-cloud-contract:pushStubsToScm

## Spring Cloud Contract Maven Plugin

## spring-cloud-contract:pushStubsToScm

Full name:

org.springframework.cloud:spring-cloud-contract-maven-plugin:2.1.0.BUILD-SNAPSHOT:pushStubsToScm

Description:

The generated stubs get committed to the SCM repo and pushed to origin.

Attributes:

- Requires a Maven project to be executed.

### Optional Parameters

Name | Type | Since | Description
--- | --- | --- | ---
contractsMode | `StubRunnerProperties$StubsMode` | `-` | Picks the mode in which stubs will be found and registered Default value is: `CLASSPATH`. User property is: `contractsMode`.
contractsProperties | `Map` | `-` | Map of properties that can be passed to custom `StubDownloaderBuilder` User property is: `contractsProperties`.
contractsRepositoryPassword | `String` | `-` | The password to be used to connect to the repo with contracts. User property is: `contractsRepositoryPassword`.
contractsRepositoryUrl | `String` | `-` | The URL from which a contracts should get downloaded. If not provided but artifactid / coordinates notation was provided then the current Maven's build repositories will be taken into consideration User property is: `contractsRepositoryUrl`.
contractsRepositoryUsername | `String` | `-` | The user name to be used to connect to the repo with contracts. User property is: `contractsRepositoryUsername`.
deleteStubsAfterTest | `boolean` | `-` | If set to `false` will NOT delete stubs from a temporary folder after running tests Default value is: `true`. User property is: `deleteStubsAfterTest`.
outputDirectory | `File` | `-` | (no description) Default value is: `${project.build.directory}/stubs`. User property is: `stubsDirectory`.
skip | `boolean` | `-` | Set this to "true" to bypass the whole Verifier execution Default value is: `false`. User property is: `spring.cloud.contract.verifier.skip`.
taskSkip | `boolean` | `-` | Set this to "true" to bypass only JAR creation Default value is: `false`. User property is: `spring.cloud.contract.verifier.publish-stubs-to-scm.skip`.

### Parameter Details

contractsMode:

Picks the mode in which stubs will be found and registered

- Type: `org.springframework.cloud.contract.stubrunner.spring.StubRunnerProperties$StubsMode`
- Required: `No`
- User Property: `contractsMode`
- Default: `CLASSPATH`

contractsProperties:

Map of properties that can be passed to custom `StubDownloaderBuilder`

- Type: `java.util.Map`
- Required: `No`
- User Property: `contractsProperties`

contractsRepositoryPassword:

The password to be used to connect to the repo with contracts.

- Type: `java.lang.String`
- Required: `No`
- User Property: `contractsRepositoryPassword`

contractsRepositoryUrl:

The URL from which a contracts should get downloaded. If not provided but artifactid / coordinates notation was provided then the current Maven's build repositories will be taken into consideration

- Type: `java.lang.String`
- Required: `No`
- User Property: `contractsRepositoryUrl`

contractsRepositoryUsername:

The user name to be used to connect to the repo with contracts.

- Type: `java.lang.String`
- Required: `No`
- User Property: `contractsRepositoryUsername`

deleteStubsAfterTest:

If set to `false` will NOT delete stubs from a temporary folder after running tests

- Type: `boolean`
- Required: `No`
- User Property: `deleteStubsAfterTest`
- Default: `true`

outputDirectory:

(no description)

- Type: `java.io.File`
- Required: `No`
- User Property: `stubsDirectory`
- Default: `${project.build.directory}/stubs`

skip:

Set this to "true" to bypass the whole Verifier execution

- Type: `boolean`
- Required: `No`
- User Property: `spring.cloud.contract.verifier.skip`
- Default: `false`

taskSkip:

Set this to "true" to bypass only JAR creation

- Type: `boolean`
- Required: `No`
- User Property: `spring.cloud.contract.verifier.publish-stubs-to-scm.skip`
- Default: `false`